#include <bits/stdc++.h>
using namespace std;
bool q[5], stop=false;
int T=6, N, M, t;
int main() {
	ios::sync_with_stdio(false); cin.tie(0);
	short n;
	if(T==6) {
		cin>>T;
		t=T-1;
	}
	T--;
	cin>>N>>M;
	unsigned long long A[N], B[M];
	for(int j=0; j<N; j++)
	cin>>A[j];
	for(int j=0; j<M; j++)
	cin>>B[j];
	for(int X=2; true; X++) {
		q[T]=true;
		for(int j=1; j<N; j++) {
			if(A[j]%X!=A[0]%X) {
				q[T]=false;
				break;
			}
		}
		for(int j=0; j<M; j++) {
			if(B[j]%X==A[0]%X) {
				q[T]=false;
				break;
			}
		}
		n=0;
		for(int j=0; j<N; j++) {
			if(X>A[j])
			n++;
		}
		if(n>1||q[T])
		break;
	}
	if(T>0)
	main();
	if(!stop) {
		for(int j=t; j>=0; j--)
		cout<<(q[j]?1:0)<<endl;
	}
	stop=true;
	return 0;
}